using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.BLL
{
    /// <summary>
	/// 回访结果记录表
	/// </summary>
	public partial class T_Bus_VisitResultRecords
    {
        private readonly CallCenterApi.DAL.T_Bus_VisitResultRecords dal = new CallCenterApi.DAL.T_Bus_VisitResultRecords();
        public T_Bus_VisitResultRecords()
        { }
        #region  BasicMethod
        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Bus_VisitResultRecords model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Bus_VisitResultRecords GetModel(int F_VRRId)
        {

            return dal.GetModel(F_VRRId);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Bus_VisitResultRecords> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Bus_VisitResultRecords> DataTableToList(DataTable dt)
        {
            List<CallCenterApi.Model.T_Bus_VisitResultRecords> modelList = new List<CallCenterApi.Model.T_Bus_VisitResultRecords>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                CallCenterApi.Model.T_Bus_VisitResultRecords model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }

        #endregion  BasicMethod
        #region  ExtensionMethod
        public int AddInfo(Model.T_Bus_VisitResult model,string user,string guid)
        {
            Model.T_Bus_VisitResultRecords resmodel = new Model.T_Bus_VisitResultRecords();
            resmodel.F_AssignedId = model.F_AssignedId;
            resmodel.F_CallRecordId = model.F_CallRecordId;
            resmodel.F_CreateTime = model.F_CreateTime;
            resmodel.F_CreateUser = model.F_CreateUser;
            resmodel.F_DeleteTime = model.F_DeleteTime;
            resmodel.F_DeleteUser = model.F_DeleteUser;
            resmodel.F_File = model.F_File;
            resmodel.F_IsDelete = model.F_IsDelete;
            resmodel.F_IsSatisfie = model.F_IsSatisfie;
            resmodel.F_LimitTime = model.F_LimitTime;
            resmodel.F_Remark = model.F_Remark;
            resmodel.F_Result = model.F_Result;
            resmodel.F_State = model.F_State;
            resmodel.F_Type = model.F_Type;
            resmodel.F_VisitUser = model.F_VisitUser;
            resmodel.F_VRId = model.F_Id;
            resmodel.F_WorkOrderId = model.F_WorkOrderId;
            resmodel.F_Guid = guid;
            resmodel.F_ReUser = user;
            resmodel.F_ReTime = DateTime.Now;
            return dal.Add(resmodel);
        }

        #endregion  ExtensionMethod
    }
}
